--- app_directed_pickup.c.orig	2007-08-08 15:39:50.000000000 +0200
+++ app_directed_pickup.c	2007-08-08 15:41:06.000000000 +0200
@@ -39,14 +39,15 @@
 #include "asterisk/module.h"
 #include "asterisk/lock.h"
 #include "asterisk/app.h"
+#include "asterisk/features.h"
 
 static const char *tdesc = "Directed Call Pickup Application";
 static const char *app = "Pickup";
 static const char *synopsis = "Directed Call Pickup";
 static const char *descrip =
-"  Pickup(extension[@context]): This application can pickup any ringing channel\n"
+"  Pickup([extension[@context][&extension2@context...]]): This application can pickup any ringing channel\n"
 "that is calling the specified extension. If no context is specified, the current\n"
-"context will be used.\n";
+"context will be used. If no extension is specified, a call in the same pickupgroup will be picked up\n";
 
 STANDARD_LOCAL_USER;
 
@@ -60,12 +61,13 @@
 	char *tmp = NULL, *exten = NULL, *context = NULL;
 	char workspace[256] = "";
 
+	LOCAL_USER_ADD(u);
 	if (ast_strlen_zero(data)) {
-		ast_log(LOG_WARNING, "Pickup requires an argument (extension) !\n");
-		return -1;	
+	       res=ast_pickup_call(chan);
+	       LOCAL_USER_REMOVE(u);
+	       return res;
 	}
 
-	LOCAL_USER_ADD(u);
 	
 	/* Get the extension and context if present */
 	exten = data;
@@ -167,3 +169,4 @@
 {
 	return ASTERISK_GPL_KEY;
 }
+
